
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>解读ASP.NET 5 &amp; MVC6系列教程（3）：项目发布与部署_自学过程 / iVAN</title>

    <meta name="description" content="解读ASP.NET 5 &amp; MVC6系列教程（3）：项目发布与部署_自学过程 本章我们将讲解ASP.NET5项目发布部署相关的内容,示例项目以我们前一章创建的BookStore项目为例. 发布前的设置 由于新版ASP.NET5支持多版本DNX运行环境的发布和部署,所以在部署之前,我们需要设定部署的目标DNX(即之前的KRE). 步骤:右键BookStore项目-&gt;属性-&gt;Application选项卡,选择DNX的版本,本例中,选择dnx-coreclr-win-x64.1.0.0-beta4. 在project.json文件的commands节点,我们可以看到 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">解读ASP.NET 5 &amp; MVC6系列教程（3）：项目发布与部署_自学过程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>本章我们将讲解ASP.NET5项目发布部署相关的内容，示例项目以我们前一章创建的BookStore项目为例。</p>
<p><b>发布前的设置</b></p>
<p>由于新版ASP.NET5支持多版本DNX运行环境的发布和部署，所以在部署之前，我们需要设定部署的目标DNX（即之前的KRE）。</p>
<p>步骤：右键BookStore项目-&gt;属性-&gt;Application选项卡，选择DNX的版本，本例中，选择<code>dnx-coreclr-win-x64.1.0.0-beta4</code>。</p>
<p>在<code>project.json</code>文件的<code>commands</code>节点，我们可以看到，系统默认配置了3个调试命令，分别如下：</p>
<table>
<thead>
<tr>
<th>命令</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>web</td>
<td>启动WebListener服务，该服务可以让web程序脱离IIS运行，默认地址是http://localhost:5000。</td>
</tr>
<tr>
<td>gen</td>
<td>使用该命令可以生成MVC相关的代码，比如Controller，目前还用不到。</td>
</tr>
<tr>
<td>ef</td>
<td>Entity Framework迁移命令，用于迁移数据使用，本例我们还用户不到。</td>
</tr>
</tbody>
</table>
<p>理论上来说，我们F5运行的时候，应该是启动web命令，但是在VS2015中，默认的运行环境依然是IIS Express，所以F5调试的时候，会默认启动IIS Express。</p>
<p>gen参考:http://www.jb51.net/article/87244.htm<br />
注意：web模式和IIS Express模式的程序运行端口不一样。</p>
<p>我们先F5调试运行，启动IIS Express，打开页面，一切正常。重新选择默认模拟器环境为web，再F5运行，这时候发现弹出了一个命令行窗口，并提示如下文字：</p>
<pre>
[INFORMATION:Microsoft.NET.Http.Server.WebListener] Start
[INFORMATION:Microsoft.NET.Http.Server.WebListener] Listening on prefix: http://localhost:5000/
Started</pre>
<p>代码没有出错，但是并没有打开浏览器窗口，我们手工打开一个浏览器访问上述网址，即可看到该示例程序的界面，此时说明，该BookStore已经成功运行在5000端口了。其实该模式下的浏览器自动打开功能默认是关闭的，可以通过如下方式开启自动打开功能：</p>
<p>步骤：右键BookStore项目-&gt;属性-&gt;Debug选项卡，勾选Launch Brower复选框，并在输入框里输入上述网址即可（此时会在项目的Properties目录下生成一个debugSettings.json文件来保存上述信息）。</p>
<p>再次F5运行，即可看到自动打开的浏览器界面。</p>
<p><strong>应用程序参数</strong><br />
在该Debug选项卡中，我们还看到一个应用程序参数（<code>Application Arguments</code>）输入框，该输入框可以传入多种参数，这些参数可以在<code>Startup.cs</code>里，通过<code>Configuration</code>的<code>AddCommandLine</code>方法进行收集并利用。</p>
<p><strong>环境变量</strong><br />
同理，在Debug选项卡的最下面还有一个环境变量（<code>Environment Variables</code>）输入框，可以让我们在调试的时候自定义一些环境变量的值（key/value），然后通过<code>Configuration</code>的<code>AddEnvironmentVariables</code>方法进行收集并利用。</p>
<p>上述参数和环境变量的具体使用方式，请参考配置信息管理章节。</p>
<p><b>发布流程分析</b></p>
<p>在之前的MVC程序中，我们一般都是通过右键项目，选择发布（Publish）的方式来发布程序的，这一次我们也来看看这种方式。</p>
<p>首先，右键-&gt;发布-&gt;Profile（选择File System）-&gt;选择<code>D:\BookStore</code>-&gt;选择<code>Release/coreclr</code>-&gt;下一步，最终点击发布。在在Output面板，我们看到出错了，错误信息如下：</p>
<pre>
正在连接到 D:\Documents\Visual Studio 2015\Projects\BookStore\BookStore\..\artifacts\bin\BookStore\Release\Publish...
C:\Program Files (x86)\MSBuild\Microsoft\VisualStudio\v14.0\Web\Microsoft.DNX.Publishing.targets(342,5): 错误 : 错误: 无法识别规则“BackupRule”。
C:\Program Files (x86)\MSBuild\Microsoft\VisualStudio\v14.0\Web\Microsoft.DNX.Publishing.targets(342,5): 错误 : 错误计数: 1。

C:\Program Files (x86)\MSBuild\Microsoft\VisualStudio\v14.0\Web\Microsoft.DNX.Publishing.targets(342,5): 错误 : An error occured during publish.
The command ["C:\Program Files (x86)\IIS\Microsoft Web Deploy\msdeploy.exe" -source:contentPath='C:\Users\Administrator\AppData\Local\Temp\PublishTemp\' -dest:contentPath='D:\Documents\Visual Studio 2015\Projects\BookStore\artifacts\bin\BookStore\Release\Publish' -verb:sync -enableRule:DoNotDeleteRule -retryAttempts:2 -disablerule:BackupRule ] exited with code [-1]。</pre>
<p>通过查看输出信息，可以发现，编译成功，但复制的时候出错，可能是powershell的问题，所以返回上述步骤，在设置（Settings）选项卡下，将取消发布脚本（Publish Scripts）下的使用PowerShell脚本发布的复选框。重新发布，成功了。</p>
<p>打开发布目录D:\BookStore，发现生成了如下目录和文件：</p>
<table>
<thead>
<tr>
<th>目录或文件</th>
<th>描述</th>
</tr>
</thead>
<tbody>
<tr>
<td>approot</td>
<td>应用程序目录</td>
</tr>
<tr>
<td>wwwroot</td>
<td>静态文件目录</td>
</tr>
<tr>
<td>gen</td>
<td>linux shell命令文件</td>
</tr>
<tr>
<td>gen.cmd</td>
<td>cmd命令文件</td>
</tr>
<tr>
<td>web</td>
<td>linux shell命令文件</td>
</tr>
<tr>
<td>web.cmd</td>
<td>cmd命令文件</td>
</tr>
</tbody>
</table>
<p>看到cmd文件的扩展名，我们可以猜想这些命令是用于执行相关的命令，比如<code>web.cmd</code>可能就是用于启动程序的；而非cmd扩展名文件，我们则猜想可能是用于linux/mac运行的命令。</p>
<p>我们来试一下，点击<code>web.cmd</code>文件，该文件执行以后显示的信息和我们在Debug程序时弹出的信息一样，通过访问提示中的网址，我们可以验证应用程序已经正常运行了。这种模式即时我们所说的自宿主（Self-Host）运行模式。</p>
<p>再试一下IIS是否能够运行该程序，将IIS站点指向到<code>wwwroot</code>目录，打开网址，也是可以正常访问的。打开<code>wwwroot</code>文件夹进行查看，静态文件一应俱全，但是发现bin目录下并没有我们的项目DLL（<code>BookStore.dll</code>），而是多了一个<code>AspNet.Loader.dll</code>，而且根目录下还多了一个<code>web.config</code>文件，内容如下:</p>
<pre>
&lt;?xml version="1.0" encoding="utf-8"?&gt;
&lt;configuration&gt;
 &lt;appSettings&gt;
 &lt;add key="bootstrapper-version" value="1.0.0-beta4" /&gt;
 &lt;add key="runtime-path" value="..\approot\packages" /&gt;
 &lt;add key="dnx-version" value="1.0.0-beta4" /&gt;
 &lt;add key="dnx-clr" value="coreclr" /&gt;
 &lt;add key="dnx-app-base" value="..\approot\src\BookStore" /&gt;
 &lt;/appSettings&gt;
&lt;/configuration&gt;</pre>
<p>通过查询相关信息（访问详情） ，得知<code>AspNet.Loader.dll</code>文件只是一个桥接文件，用于接收IIS转发过来的请求，然后将其转交给<code>dnx</code>进行运行，这里的<code>web.config</code>里的dnx以及项目信息的配置文件是<code>AspNet.Loader.dll</code>在转交请求时所需要的配置信息。</p>
<p>通过配置文件我们可以看到，这里配置了<code>dnx</code>的类型、版本号，程序集的路径和app的路径。打开<code>approot\src\BookStore</code>目录，我们发现，这里居然都是cs源码，虽然有个<code>bin</code>目录，但是里面也没有dll文件。而且在<code>approot\packages</code>文件夹下，居然有90个程序集文件夹（将近30M文件）。</p>
<p>通过查询网站的资料得知（这一部分内容，我们在下一节进行讲解），目前真正运行程序的运行环境是<code>DNX</code>，也被复制到<code>approot\packages\dnx-coreclr-win-x64.1.0.0-beta4</code>目录中， 而该项目依赖的所有程序集（包括System开头的）都被复制到该packages目录下了。目的就是要做到真正的跨平台运行，也就是说，将这些文件复制到linux系统下，只要有对应版本的KRE（本例中的DNX是Windows版本的）的话，就可以正常运行该程序。</p>
<p>而bin目录下没有dll文件，则是使用了微软最新的动态编译技术，即在运行的过程中，自动编译cs文件，而且一旦修改这些cs文件的话，系统将会自动再次进行编译。（感觉有点像php等脚本语言了）。虽然动态编译很高效，但是还是没有编译好的dll高效，所以微软还提供了一个选项让开发人员在调试的时候生成dll文件。具体步骤如下：</p>
<p><code>右键BookStore-&gt;属性-&gt;Build选项卡，勾选编译时生成输出（Produce outputs on build）复选框。</code></p>
<p>重新编译程序，发现在<code>BookStore\artifacts\bin\BookStore\Debug</code>目录下的2个DNX版本文件夹下都分别生成了BookStore.dll文件了，而且还顺带了Nuget的spec文件。</p>
<p>如果在发布的时候也要生成dll文件，则需要在发布（Publish）设置里进行修改，步骤如下：</p>
<p><code>右键BookStore-&gt;发布（Publish）-&gt;Settings选项卡-&gt;File Publish Options-&gt;勾选Precompile during publishing复选框。</code></p>
<p>这样就可以生成响应的dll文件， 但是这些dll文件依然不在wwwroot/bin目录下，而是在<code>approot\packages\BookStore\1.0.0</code>目录下，在该目录下有2个文件夹，分别是<code>lib</code>和<code>root</code>，以及相关的Nuget的spec文件，在lib目录下，生成的是不同dnx版本的dll文件，而root则是类似于之前的web根目录，因为在该目录下除了有视图文件以外，还和以前的结构一样，保留了bin目录，并且在bin目录下的Release文件夹下，也有一份针对不同dnx版本的dll文件副本。</p>
<p>提示：上述选择中，另外一个Delete all existing files prior to publish也可以勾选上，以便在发布时将之前发布版本的所有文件全部清空。</p>
<p>此时，我们通过web.cmd文件或者IIS模式来验证发布的文件，经验证，均可以正常运行。再仔细对比两份不同设在的发布文件，发现，除了dll文件以外，web.config文件的应用程序路径也变了，即从原来的：</p>
<pre>
&lt;add key="kre-app-base" value="..\approot\src\BookStore" /&gt;</pre>
<p>变成了如下版本：</p>
<pre>
&lt;add key="kre-app-base" value="..\approot\packages\BookStore\1.0.0\root" /&gt;</pre>
<p>而web.cmd文件的内容，也从如下内容：</p>
<pre>
@"%~dp0approot\packages\dnx-coreclr-win-x64.1.0.0-beta4\bin\dnx.exe" --appbase "%~dp0approot\src\BookStore" Microsoft.Framework.ApplicationHost web %*</pre>
<p>变成了如下内容：</p>
<pre>
@"%~dp0approot\packages\kre-coreclr-win-x64.1.0.0-beta4\bin\dnx.exe" --appbase "%~dp0approot\packages\BookStore\1.0.0\root" Microsoft.Framework.ApplicationHost web %*</pre>
<p>上述变化，我们是可以理解的，即将src源码动态编译运行的模式修改为预编译dll程序集的模式。所以，在这里我们可以看到，在源码动态编译模式下，其发布后的文件夹结构如下：</p>
<pre>
//源码动态编译模式
wwwroot/bin/Microsoft.AspNet.Loader.IIS.dll
wwwroot/Contents/site.css
wwwroot/Contents/.......................................
........................................................
wwwroot/Scripts/jquery.js
wwwroot/Scripts/........................................
........................................................
........................................................
approot/src/BootStore/project.json
approot/src/BootStore/...............................
approot/src/BootStore.Data/project.json
approot/src/BootStore.Data/..............................
approot/src/BootStore.Bussiness/project.json
approot/src/BootStore.Bussiness/.........................
approot/packages/Elmah/{version}/.......................
........................................................</pre>
<p>而dll预编译模式下的发布文件夹结构如下：</p>
<pre>
//dll预编译模式
wwwroot/bin/Microsoft.AspNet.Loader.IIS.dll
wwwroot/Contents/site.css
wwwroot/Contents/.......................................
........................................................
wwwroot/Scripts/jquery.js
wwwroot/Scripts/........................................
........................................................
........................................................
approot/packages/BootStore/{version}/...................
approot/packages/BootStore.Data/{version}/..............
approot/packages/BootStore.Bussiness/{version}/.........
approot/packages/Elmah/{version}/.......................</pre>
<p><b>IIS和web.cmd模式的不同</b></p>
<p>虽然我们对dnx内容的原理不太理解，但有一点内容，我们要记住，那就是两种模式下，对静态文件的访问模式可能不太一样。原因是因为，虽然IIS模式的根目录就是存放静态文件的地方，但是web.cmd文件事先启动的却是<code>approot\src\BookStore</code>目录或<code>approot\packages\BookStore\1.0.0\root</code>目录，两个目录下均没有静态文件，因为静态文件时在<code>wwwroot</code>目录下的，我们猜想，在这种模式下，肯定会有一种机制在来映射这些静态文件，通过查找文件发现，在<code>approot\src\BookStore</code>目录下的<code>project.json</code>文件中的<code>webroot</code>键的值，从解决方案中默认的<code>wwwroot</code>变成了<code>"../../../wwwroot"</code>，也就是说kre在映射静态文件的时候，应该是根据这个相对目录来查找这些文件的。</p>
<p>同理，<code>approot\packages\BookStore\1.0.0\root</code>目录下的<code>project.json</code>文件中的<code>webroot</code>键的值，也从<code>wwwroot</code>变成了<code>"../../../../../wwwroot"</code>（因为本来<code>project.json</code>文件的层级就深）。</p>
<p>由于IIS是通过<code>AspNet.Loader.dll</code>做中转，将请求转交给DNX来运行的，那么在IIS模式下，静态文件的请求到底是IIS来处理，还是KRE来处理呢？我们来验证一下，验证步骤如下：</p>
<p>创建一个<code>wwwroot2</code>文件夹和<code>wwwroot</code>同级，并将<code>wwwrooot</code>目录下的静态文件剪切到<code>wwwroot2</code>目录下。将<code>project.json</code>（如果是预编译模式，则需要修改root目录下的project.json）文件中的<code>webroot</code>值中的<code>wwwroot</code>修改为<code>wwwroot2</code>。继续以IIS模式运行该站点</p>
<p>结果发现，静态文件访问不了了（CSS、JS、Images均失效了），但我们再通过web.cmd运行时，这些静态文件却又可以访问了。由此得知，在IIS模式下，静态文件走的是IIS的管线Pipeline，而不是DNX的关系Pipeline。</p>
<p><b>两种发布模式下的project.json文件不同</b></p>
<p>动态编译模式和预编译dll模式这两种模式的自动发布程序，生成后的project.json文件有一些变化，具体变化如下。</p>
<p><strong>动态编译模式</strong><br />
基本上和解决方案里的project.json文件相同，唯一的不同就是webroot的相对路径的修改。</p>
<p><strong>预编译dll模式</strong><br />
原来引用的众多程序集从dependencies节点中移除了，取而代之的是BookStore程序集引用，示例如下：</p>
<pre>
"dependencies": {
 "BookStore": "1.0.0"
},</pre>
<p>另外，还多了如下两个节点值（具体功能暂不明确）：</p>
<pre>
"entryPoint": "BookStore",
"loadable": false</pre>
<p>猜想，这些不同，可能是因为在动态编译模式下需要引用这些被移除的程序集进行编译，而预编译dll模式下，都已经编译好了，所以就不再需要这些程序集了，而root目录只需要引用BookStore程序集就可以了，而BookStore程序集对这些程序集的依赖，详细在该dll程序集的nupkg文件里是可以自动解析并下载的吧（这一点待验证）。</p>
<p>以上是新版ASP.NET5项目在发布流程和相关技术的一些内容，从这里大家可以看到，ASP.NET5是彻底模块化了，IIS不再是运行MVC程序的唯一容器，任何兼容DNX的运行容器都可以运行MVC程序，程序发布包被分为approot和wwwroot两个部分，分别存放应用程序集（或源码）和静态文件，从而做到更好的分离。在下一章，我们会讨论，ASP.NET 5的运行原理。</p>
<p>注意：目前还没有办法通过复制源码的形式来进行调试，同时也没办法将IIS指向到源码中进行调试，这将会改变开发人员的开发习惯。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索iis<br />
                    ，                5<br />
                    ，                asp.net<br />
                    ，                部署<br />
                    ，                发布<br />
                    ，                项目<br />
                    ，                mvc6<br />
                                    web.cmd<br />
                                    ，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 11:47:33</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/asp-net/" title="asp&period;net">asp&period;net</a>, <a href="https://www.iamivan.net/tag/iis/" title="iis">iis</a>, <a href="https://www.iamivan.net/tag/%e9%a1%b9%e7%9b%ae/" title="项目">项目</a>, <a href="https://www.iamivan.net/tag/%e5%8f%91%e5%b8%83/" title="发布">发布</a>, <a href="https://www.iamivan.net/tag/%e9%83%a8%e7%bd%b2/" title="部署">部署</a>, <a href="https://www.iamivan.net/tag/web-cmd/" title="web&period;cmd">web&period;cmd</a>, <a href="https://www.iamivan.net/tag/mvc6/" title="mvc6">mvc6</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>解读ASP.NET 5 &amp; MVC6系列教程（3）：项目发布与部署_自学过程的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPWnXAM.html" rel="bookmark">解读ASP&period;NET 5 &amp;amp&semi; MVC6系列教程（14）：View Component&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在之前的MVC中,我们经常需要类似一种小部件的功能,通常我们都是使用Partial View来实现,因为MVC中没有类似Web Forms中的WebControl的功能.但在MVC6中,这一功能得到了极大的改善.新版MVC6中,提供了一种叫做View Component的功能. 你可以将View Component看做是一个mini的Controller--它只负责渲染一小部分内容,而非全部响应,所有Partial View能解决的问题,你都可以使用View Component来解决,比如:动态			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJwRvvb.html" rel="bookmark">解读ASP&period;NET 5 &amp;amp&semi; MVC6系列教程（12）：基于Lamda表达式的强类型Routing实现&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面的深入理解Routing章节,我们讲到了在MVC中,除了使用默认的ASP.NET 5的路由注册方式,还可以使用基于Attribute的特性(Route和HttpXXX系列方法)来定义.本章,我们将讲述一种基于Lambda表达式的强类型类型. 这种方式的基本使用示例如下: services.Configure&lt;MvcOptions&gt;(opt =&gt; { opt.EnableTypedRouting(); opt.GetRoute(&quot;homepage&quot;, c =&gt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvYn7Ab.html" rel="bookmark">解读ASP&period;NET 5 &amp;amp&semi; MVC6系列教程（13）：TagHelper&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在新版的MVC6中,微软提供了强大的TagHelper功能,以便让我们摆脱如下的臃肿代码: @Html.LabelFor(model =&gt; model.FullName) @Html.EditFor(model =&gt; model.FullName) @Html.ValidationMessageFor(model =&gt; model.FullName) 引入新功能TagHelper以后,我们只需要这样定义就可以了,代码如下: @addTagHelper &quot;*, Microsoft			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmRor5z.html" rel="bookmark">解读ASP&period;NET 5 &amp;amp&semi; MVC6系列教程（1）：ASP&period;NET 5简介&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ASP.NET 5简介 ASP.NET 5是一个跨时代的改写,所有的功能和模块都进行了独立拆分,做到了彻底解耦.为了这些改写,微软也是蛮 拼的,几乎把.NET Framwrok全部改写了一遍,形成了一个.NET Core的东西. 在.NET Core里一切都是可配置的,包括Session.MVC等功能,而一切可配置的功能都是可以在Nuget上进行下载. 目前ASP.NET 5依旧兼容老的.NET Framwrok,但要在进行跨平台的部署,还是只能使用新改版的.NET Core CLR. 目前的A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zenOlNb.html" rel="bookmark">解读ASP&period;NET 5 &amp;amp&semi; MVC6系列教程（15）：MvcOptions配置&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				程序模型处理 IApplicationModelConvention 在MvcOptions的实例对象上,有一个ApplicationModelConventions属性(类型是:List&lt;IApplicationModelConvention&gt;),该属性IApplicationModelConvention类型的接口集合,用于处理应用模型ApplicationModel,该集合是在MVC程序启动的时候进行调用,所以在调用之前,我们可以对其进行修改或更新,比如,我们可以针对所有的Control			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWx0aAp.html" rel="bookmark">解读ASP&period;NET 5 &amp;amp&semi; MVC6系列教程（6）：Middleware详解&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在第1章项目结构分析中,我们提到Startup.cs作为整个程序的入口点,等同于传统的Global.asax文件,即:用于初始化系统级的信息(例如,MVC中的路由配置).本章我们就来一一分析,在这里如何初始化这些系统级的信息. 新旧版本之间的Pipeline区别 ASP.NET 5和之前版本的最大区别是对HTTP Pipeline的全新重写,在之前的版本中,请求过滤器的通常是以HttpModule为模块组件,这些组件针对HttpApplication里定义的各个周期内的事件进行响应,从而用于实现			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK374db.html" rel="bookmark">解读ASP&period;NET 5 &amp;amp&semi; MVC6系列教程（11）：Routing路由&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				新版Routing功能介绍 在ASP.NET 5和MVC6中,Routing功能被全部重写了,虽然用法有些类似,但和之前的Routing原理完全不太一样了,该Routing框架不仅可以支持MVC和Web API,还支持一般的ASP.NET5程序.新版的改变有如下几个部分. 首先,Routing系统是基于ASP.NET 5的,是一个独立于MVC的路由框架,而不是基于MVC的.MVC只是在上面扩展了一个快捷方式而已. 其次,在ASP.NET 5中,MVC和Web API控制器没有区别了,即合二为一了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE4yo3z.html" rel="bookmark">解读ASP&period;NET 5 &amp;amp&semi; MVC6系列教程（2）：初识项目&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				初识项目 打开VS2015,创建Web项目,选择ASP.NET Web Application,在弹出的窗口里选择ASP.NET 5 Website模板创建项目,图示如下: 我们可以看到,此时Web Forms\MVC\Web API复选框都选择不了,原有是因为在ASP.NET 5中做了大量更改,移除了Web Forms功能,将MVC.Web API.Web Pages这些功能合在了一起,所以自然就不需要这些复选框了.另外由于是CTP版,所以目前还没有提供单元测试项目的创建. 新创建的项目在VS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pX0d8vp.html" rel="bookmark">解读ASP&period;NET 5 &amp;amp&semi; MVC6系列教程（10）：Controller与Action&lowbar;自学过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				我们知道在MVC5和之前的版本,两个框架的生命周期是不一样的,在新版MVC6中,MVC Controller/Web API Controller已经合二为一了,本章我们主要讲解Controller和Action的定义与使用,以及在MVC框架中,如何根据路由查询相应的Controller和Action. Controller&amp;Action的定义和使用 在新版MVC6框架中,依然提供了一个Controller基类,在这里除了依然提供了Url.RouteData.HttpContext.Reques			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8ZZZb.html" rel="bookmark" class="title">冒号和他的学生们（连载2）&mdash;&mdash;首轮提问</a>
					<div>
						首轮提问 敬畏老师莫如敬畏真理 --题记 众人面面相觑,一阵沉默后开始窃窃私语,显然有些不太习惯这种教学方式--笔记本上还没写两个字呢,老师就把球给踢回来了. 冒号也不说话,只是微笑地望着大家. 还是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVGBDb.html" rel="bookmark" class="title">谈谈：怎么筛选网站合适的关键词？</a>
					<div>
						寻找了很多的关键词不是每一个都能使用,都能添加到你的title标签里面.这个时候我们就要从这么多的关键词里面挑选适合我们网站的,这是很重要的一步; 我们的建议:挑选的关键词竞争度不要太高,综合比较以后 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM695Yb.html" rel="bookmark" class="title">负载平衡环境下的ASP会话管理（二）</a>
					<div>
						仅当web 范围内的第一次点击进行负载平衡这种方法也称为前端负载平衡,它易于描述,但是有可能不适于执行.为了实现真正的负载平衡,每次请求都要重新平衡用户.但是在大多数情况下,前端负载平衡就已经足够满足 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4PjJz.html" rel="bookmark" class="title">CSS实例：三列自由式布局 770-1024自适应宽度</a>
					<div>
						css|自适应 这个例子是最典型实用的上中下,并且中间分三列的css布局,有以下2个特点: 1. 中间三列效果,可以任意实现单列背景色. 2. 整体最窄770px,最宽1024px,也就是说窗口小于7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/6b3DyAM.html" rel="bookmark" class="title">运动的螺旋效果 as3&period;0</a>
					<div>
						从内至外效果: 效果代码如下: var speed:Number = 0.3; var radius:Number = 0; var angle:Number = 0; var xpos:Number ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjAJlp.html" rel="bookmark" class="title">如何将sqlite数据库移植到ARM开发板上</a>
					<div>
						近段时间在学数据库,因为自身需求,所以注重研究了点嵌入式sqlite数据库, SQLite,是一款轻型的数据库,是遵守ACID的关联式数据库管理系统,它的设计目标是嵌入式的,而且目前已经在很多嵌入式产 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOXl0M.html" rel="bookmark" class="title">C&num;实现十进制数转换为二进制、八进制、十六进制数的算法</a>
					<div>
						using System; using System.Collections.Generic; using System.ComponentModel; using System.Data; usin ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAEmKb.html" rel="bookmark" class="title">Python中下划线的使用方法</a>
					<div>
						这篇文章主要介绍了Python中下划线的使用方法,是为python编程学习中的基本知识,需要的朋友可以参考下     本文将讨论Python中下划线(_)字符的使用方法.我们将会看到,正如Python ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKNNOM.html" rel="bookmark" class="title">httpclient模拟登陆具体实现</a>
					<div>
						 最简单的方法就是通过得到的cookie定制一个httpclient,感兴趣的朋友可以了解下本文 httpclient模拟登陆(使用js设置cookie)  代码如下: &lt;html&gt;  & ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWQEAp.html" rel="bookmark" class="title">javascript获取flash版本号的方法</a>
					<div>
						 下面我们来介绍两个js函数判断用户是否安装了flash,如果安装了flash再来获取 flash版本号并且给出提示. 例1 获取各浏览器的版本号,如需获取具体版本号数字 代码如下: function ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDYveKb.html" rel="bookmark" class="title">win7电脑无法上网并提示错误代码118的解决办法</a>
					<div>
						  用户使用电脑最常的操作就是连接网络.造成连接网络失败无法上网的原因很多,大部分错误都会出现提示代码,如果在Win7系统中遇到无法上网,提示错误代码118怎么办呢? 解决办法: 1.首先同时按下键盘 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq83VKb.html" rel="bookmark" class="title">笔记本电脑拔掉电源屏幕会黑一下怎么办</a>
					<div>
						  1.右击桌面空白处,选择点击屏幕分辨率; 2.点击高级设置,设置屏幕刷新率,可以都设置为60Hz或者都设置为50Hz; 3.右击右下角的电源图标,选择打开电源选项,点击&quot;更改计划设置&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0WjPJb.html" rel="bookmark" class="title">&lpar;cljs&sol;run-at &lpar;JSVM&period; &colon;browser&rpar; &amp;quot&semi;命名空间就这么简单&amp;quot&semi;&rpar;</a>
					<div>
						前言  一个cljs文件定义一个命名空间,通过命名空间可以有效组织代码,这是构建大型系统必备的基础设施.本篇我们就深入理解cljs中的命名空间吧! 好习惯从&quot;头&quot;开始 每个cljs ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7P9Kz.html" rel="bookmark" class="title">obj-c编程10&colon;Foundation库中类的使用&lpar;4&rpar;&lbrack;文件管理&comma;查询当前进程信息&rsqb;</a>
					<div>
						    接上一篇文件管理博文.我们可以用NSPathUtilities.h中包含的NSString函数和分类扩展来以兼容的方式处理路径.下面凡是有系统编程经验的童鞋都知道是啥意思了: #import  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0Q3g7p.html" rel="bookmark" class="title">java-求解为何一直404，底层用的spring&plus;springmvc&plus;mybatis</a>
					<div>
						问题描述 求解为何一直404,底层用的spring+springmvc+mybatis 解决方案 你的url最后有.do ,那么你的web.xml中dispatcherServlet中是拦截.do 的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/My3DKdz.html" rel="bookmark" class="title">周志华CAIS大会现场演讲：人工智能的探讨</a>
					<div>
						9月12日上午,南京金秋洽谈会&quot;2017中国人工智能峰会(CAIS 2017)&quot;在南京国际博览会议中心盛大开幕.本次峰会以&quot;创新.变革.突破&quot;为主题,并设两大主 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MA7NWnz.html" rel="bookmark" class="title">c&plus;&plus;-vtk中求组合立体图形体积的方法</a>
					<div>
						问题描述 vtk中求组合立体图形体积的方法 比如一个正方体,以的它的一个顶点为球心画个球,怎么算出这个组合体的体积..关键就是算出重叠部分,有关于polydata求交集这样的类吗 解决方案 如果球半径 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK2Vnb.html" rel="bookmark" class="title">利用matlab回复一副抖动图像的程序是什么？</a>
					<div>
						问题描述 利用matlab回复一副抖动图像的程序是什么? 用手机拍了一张图像,由于拍摄过程中手机抖动了,图像不清晰了,怎么用radon等matlab函数将其复原 解决方案 搜一下matlab维纳滤波就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJAV46p.html" rel="bookmark" class="title">看，会唱歌的炫酷飞碟！</a>
					<div>
						摘要: 主打智能的音响已经满大街,想让用户买账,产品就得够酷.最近接触到的Crazybaby的音响Mars,采用了磁悬浮加低音炮组合,看起来就够狂拽酷炫. 飞碟形状的发声单元静静悬浮在空中 主打智能的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1r0jjp.html" rel="bookmark" class="title">vs2015控制台出libpng warning&colon; iCCP&colon; Not recognizing known sRGB profile that has been</a>
					<div>
						问题描述 看了一些方案,是其他ide的.http://blog.jsinh.in/libpng-warning-iccp-not-recognizing-known-srgb-profile-that ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKoEBb.html" rel="bookmark" class="title">shell 监控局域网的主机是否up（转）</a>
					<div>
						#!/bin/bash for ((i=30;i&lt;60;i++)) ;do ping -c 3 172.31.0.$i&gt;/dev/null #ping -c 172.31.0.30 ~17 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRQZNb.html" rel="bookmark" class="title">IBM RSA &lpar;IBM rational software architect &rpar; V8 学习之五 C&plus;&plus;继承设计</a>
					<div>
						原文http://blog.csdn.net/ztz0223/article/details/7599935 其实整个系列的文章,主要是想自己给自己留个备忘,现在记性很差,发帖吗,也方便热爱学习的同学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2RvVQb.html" rel="bookmark" class="title">文件同步类SimFileSync&period;class&period;php</a>
					<div>
						使用方法:  Java代码   &lt;?php   require 'SimFileSync.class.php';      // 新建实例   $sync = new SimFileSync() ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJ82mp.html" rel="bookmark" class="title">看着阿里宰割自己的新浪微博</a>
					<div>
						今天微博上流传爱淘要与微淘合并的消息,笔者看到后冷汗涔涔,阿里这是要玩死新浪微博的节奏啊?先投资新浪微博,守住最重要社会化电商入口,之后再大力发展自己的社会化电商产品微淘与爱淘,最后将移动端微淘与PC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgVO8M.html" rel="bookmark" class="title">extjs5 如何根据行号和列号，得到一个单元格</a>
					<div>
						问题描述 extjs5 如何根据行号和列号,得到一个单元格,我看以前的getCell(rowIndex,colIndex)方法在5里没有了,请问该如何获得呢 解决方案 请查看官方api http:// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXO8Bb.html" rel="bookmark" class="title">Android使用SAX解析XML</a>
					<div>
						SAX是一个解析速度快并且占用内存少的xml解析器,非常适合用于Android等移动设备. SAX解析XML文件采用的是事件驱动,也就是说,它并不需要解析完整个文档,在按内容顺序解析文档的过程中,SA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkEr1M.html" rel="bookmark" class="title">《程序员的呐喊》一一1&period;9  作者手记：变换</a>
					<div>
						1.9 作者手记:变换 程序员的呐喊 这篇是我为奥莱利的Ruby博客而写的文章,我原来是那里的客座博主,后来觉得厌烦就退出了.当然我还是写了三四篇东西的. 事实上回想起来,我退出的主要原因是稍后不久我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1Y3ob.html" rel="bookmark" class="title">php SQLite学习笔记与常见问题分析第1&sol;2页&lowbar;php技巧</a>
					<div>
						直到学会! 学之前找资料 SQLite的sql ATTACH DATABASE BEGIN TRANSACTION comment COMMIT TRANSACTION COPY CREATE IND ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkXyOM.html" rel="bookmark" class="title">第十三节--对象串行化&lowbar;php基础</a>
					<div>
						/* +-------------------------------------------------------------------------------+ | = 本文为Haohappy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvZ3JM.html" rel="bookmark" class="title">彩虹QQ：庞升东的木马计</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 &quot;彩虹QQ门&quot; ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.065 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
